<?php
/*
Plugin Name: WPLMS Quiz Certificates
Plugin URI: https://wplms.io
Description: Certificates for Quizzes in WPLMS
Version: 1.0
Author: WPLMS, Maximus
Author URI: https://wplms.io
License: GPL2
*/
 if ( ! defined( 'ABSPATH' ) ) exit;

class WPLMS_Quiz_Certificates{

    public static $instance;

    var $schedule;

    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new WPLMS_Quiz_Certificates();

        return self::$instance;
    }

    private function __construct(){

    	add_filter('wplms_quiz_metabox',array($this,'certificate_meta'));

  		add_action('wplms_evaluate_quiz',array($this,'award_certificate'),10,4);
  		add_action('bp_before_profile_content',array($this,'show_quiz_certificates'),99);

      add_action('wplms_after_quiz_message',array($this,'remove_pdf_certificate_the_content_filter'),1);

  		add_action('wp_footer',function(){
  			if(is_page(vibe_get_option('create_course'))){ ?><style>
  				.element_overlay_quiz .vibe_vibe_certificate_template{display:block !important;}
  			</style><?php }
  		},99);

      add_shortcode('quiz_score',array($this,'quiz_score'));

      add_filter('wplms_certificate_code_course_id',array($this,'capture_quiz_id'),999);
    }


    function capture_quiz_id($code){

      if(empty($code)){
        $code = $_REQUEST['certificate_code'];
      }
        $codes = explode('-',$code);
        if(get_post_type($codes[1]) == 'quiz'){
        return $codes[1];
      }

      return $code;
    }


    function remove_pdf_certificate_the_content_filter(){

      if(class_exists('Wplms_Pdf_Certificates_Generate')){
          $gen = Wplms_Pdf_Certificates_Generate::init();
          remove_filter('the_content',array($gen,'certificate_builder'));
      }
      
    }

    function certificate_meta($meta_properties){

    		$meta_properties[]= array(
    			'label'	=> __('Certificate Template','wplmsqc'), // <label>
				'desc'	=> __('Select a Certificate Template','wplmsqc'), // description
				'id'	=> 'vibe_certificate_template', // field id and name
				'type'	=> 'selectcpt', // type of field
		        'post_type' => 'certificate'
			);
			$meta_properties[]= array(
    			'label'	=> __('Certificate Awarding Marks/Score','wplmsqc'), // <label>
				'desc'	=> __('Award certificate when user scores more than this value. 0 or Blank to disable.','wplmsqc'), // description
				'id'	=> 'vibe_certificate_score', // field id and name
				'type'	=> 'text', // type of field
			);
    	return $meta_properties;
    }

    function award_certificate($quiz_id,$marks,$user_id,$max){

    	$certificate_score = get_post_meta($quiz_id,'vibe_certificate_score',true);
    	if($certificate_score <=$marks ){
	    	$certificates = get_user_meta($user_id,'certificates',true);
	    	if(empty($certificates)){$certificates = array();}
        if(!in_array($quiz_id, $certificates)){
          $certificates[]=$quiz_id;
          update_user_meta($user_id,'certificates',$certificates);
        }
	    	do_action('wplms_certificate_earned',$quiz_id,$pass,$user_id,1);
	    }
    }


    function show_quiz_certificates(){
    	$user_id=bp_displayed_user_id();
     
  
		if(function_exists('bp_current_action') && bp_current_action() !== 'public')
		    return;

		$certis=vibe_sanitize(get_user_meta($user_id,'certificates',false));

		$show_quiz_certificats = 0;

		//Course ID spoofed by Quiz Id
		if(isset($certis) && is_Array($certis) && count($certis)){
         
          if(isset($certis) && is_Array($certis)) 
           foreach($certis as $certi){
              if(function_exists('bp_get_course_certificate')){

                if(!empty($certi) && get_post_type($certi) == 'quiz'){
	                	if(empty($show_quiz_certificats)){
	                		 echo '<div class="certifications"><h6>'.__('Quiz Certifications','vibe').'</h6><ul class="slides">';
	                		 $show_quiz_certificats= 1;
	                	}
                  		$url = bp_get_course_certificate('user_id='.$user_id.'&course_id='.$certi);
                  		$class = '';
                  		$class = apply_filters('bp_course_certificate_class','',array('course_id'=>$certi,'user_id'=>$user_id));
                  		if(isset($_GET['regenerate_certificate']) || (strpos($url, 'jpeg') === false) ) {
                    		$class .=' regenerate_certificate';
                  		}
    
                  		echo '<li><a href="'.$url.'" class="ajax-certificate '.$class.'" data-user="'.$user_id.'" data-course="'.$certi.'" data-security="'.wp_create_nonce($user_id).'"><i class="icon-certificate-file"></i><span>'.get_the_title($certi).'</span></a></li>';
                	}
               }
            }
            if($show_quiz_certificats){
           		echo '</ul></div>';  
            }
         
        }
    }


    function quiz_score($atts, $content = null){
      $user_id = $_GET['u'];
      $quiz_id = $_GET['c'];
      $status = bp_course_get_user_quiz_status($user_id,$quiz_id);
      if($status == 4){
        return get_post_meta($quiz_id,$user_id,true);
      }
    }

}

WPLMS_Quiz_Certificates::init();